
import pytest
from tdd_exo_1 import fizz_buzz


class TestFizzBuzz:
    """
    fizz_buzz function tests class
    """
    @pytest.mark.smoke
    def test_should_raise_type_error_exception_when_not_an_int(self):
        with pytest.raises(TypeError):
            fizz_buzz('not_an_int')

    @pytest.mark.parametrize('number', [3, 6, 9, 12])
    def test_should_return_fizz_when_multiple_of_3(self, number: int):
        assert fizz_buzz(number) == 'Fizz'

    @pytest.mark.parametrize('number', [5, 10, 20, 50])
    def test_should_return_buzz_when_multiple_of_5(self, number):
        assert fizz_buzz(number) == 'Buzz'

    @pytest.mark.parametrize('number', [15, 30, 45, 60])
    def test_should_return_fizzbuzz_when_multiple_of_3_and_5(self, number):
        assert fizz_buzz(number) == 'FizzBuzz'

    @pytest.mark.parametrize('number', [1, 7, 8, 22])
    def test_should_return_the_number_when_no_multiple(self, number):
        assert fizz_buzz(number) == number
